<?php
/*
 * Beautifier v3.0 - a source code syntax highlighter for PmWiki
 * Copyright 2003-2004 by Jason Perkins (jason@sim8.com)
 * Beautifier module written by and (C) Mike Jewell
 *
 * This file is part of PmWiki; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * See http://www.pmichaud.com/wiki/Cookbook/Beautifier for info.
 */

$beautifiers = array();
SDV($BeautifierOutputType, "HTML");
 
$BEAUT_PATH = "local/php";
include_once("php/Beautifier/Init.php");
include_once("php/Output/Output_HTML.php");
include_once("php/Output/Output_css.php");

/* markup deprecated in version 3.1 */
$InlineReplacements["/^=beautify\\s+(\\S+)\\s+$KeepToken(\\d+)$KeepToken/e"] = "do_beautify('$1','$2');";

function register_beautifier($language)
{
	global $beautifiers, $InlineReplacements, $KeepToken;
	include_once("php/HFile/HFile_".$language.".phps");
	array_push($beautifiers, $language);
	
	/* Add the =lang markup */
	$InlineReplacements["/^=$language\\s+$KeepToken(\\d+)$KeepToken/e"] = "do_beautify('$language','$1');";
}

function do_beautify($language, $keepindex) {
  global $KPV, $BeautifierOutputType;
  $code = str_replace(array('&lt;','&gt;','&amp;'), array('<','>','&'), $KPV[$keepindex]);  
  
  if ($BeautifierOutputType != "css")
		$BeautifierOutputType = "HTML";
		
  eval("\$beautifier = new HFile_".$language."();");
  eval("\$hl = new Core(\$beautifier, new Output_".$BeautifierOutputType."());");
  $results = "<pre class='sourcecode'>".$hl->highlight_text($code)."</pre>";

  return Keep($results);
}

?>